# fna_cw.tcl:  Complex widgets.
# RCS Id: $Id: fna_cw.tcl,v 1.0.0.2 1997/01/09 02:09:47 ndanger Alpha $


# fna:cw_version:  Return the version of this file.

proc fna:cw_version {} {
  return [fna:ver_rcs {$Revision: 1.0.0.2 $} {$State: Alpha $}]
}


set FNA(cwint,fileselect,dir) ""
set FNA(cwint,fileselect,dirlist) {}
set FNA(cwint,fileselect,file) ""
set FNA(cwint,fileselect,window) ""
set FNA(cwint,fileselect,showhidden) 0
set FNA(cwint,fileselect,filter) "*"
set FNA(cwint,fileselect,autoposn) ul
set FNA(cwint,fileselect,modal) 0

set FNA(cw,combowin,hpackdefs) {-fill x -expand yes}

proc fna:util_tk3 {} {
  global tk_version
  if {[lindex [split $tk_version .] 0] == 3} {return 1}
  return 0
}

proc fna:util_tk4 {} {
  global tk_version
  if {[lindex [split $tk_version .] 0] == 4} {return 1}
  return 0
}


proc fna:cw_init {} {
  if {[info procs fna:bw_version] == ""} {source fna_bw.tcl}
}

proc _fna:cw_trace {array element op} {
  global FNA
  
  if {$element == "cwint,fileselect,file"} {
    if {$FNA(cwint,fileselect,file) == ""} \
      {$FNA(cwint,fileselect,actbutton) configure -state disabled} \
      {$FNA(cwint,fileselect,actbutton) configure -state normal}
  }
  
}


proc fna:cw_buttonpanel {w def blist {packargs {-padx 5 -fill x -expand 1}} 
                         args} {
    
    frame $w -relief raised -borderwidth 1
    set buttons {}

    for {set b 0} {$b < [llength $blist]} {incr b} {
	set n [fna:bw_uniquesubwindow $w button]
	button $n -text [lindex $blist $b]
	if {$b == $def} {$n configure -relief groove -bd 5}
	eval pack $n -side left $packargs
	lappend buttons "$n"
    }
    
    if {[llength $args] != 0} {
   	foreach b $buttons {eval $b configure $args}
    }

    return $buttons

}


proc fna:cw_buttonpanelcmd {w def blist {packargs {-padx 5 -fill x -expand 1}}
                            args} {

    global BW
    
    set blabels ""
    set cmds ""
    foreach b $blist {
    	lappend blabels [lindex $b 0]
    	lappend cmds [lindex $b 1]
    }
    set buttons [fna:cw_buttonpanel $w $def $blabels $packargs]
    if {[llength $args] != 0} {
    	foreach b $buttons {eval "$b configure " $args}
    }
    for {set i 0} {$i < [llength $buttons]} {incr i} {
    	if {![string match "" [lindex $cmds $i]]} \
    	  {[lindex $buttons $i] configure -command "[lindex $cmds $i]"} \
    	  {[lindex $buttons $i] configure -state disabled}
    }
    return $buttons
    
}
    

proc fna:cw_combowin {w args} {

	global FNA
	
	foreach vw $args {
	    set panel [fna:bw_uniquesubwindow $w frame]
	    frame $panel
	    pack $panel -in $w -side top -fill both
	    set optstart 0
	    for {set i 0} {$i < [llength $vw]} {incr i} {
	    	if {[string first "-" [lindex $vw $i]] == 0} {
	    	    set optstart $i
	    	    break
	    	}
	    }
	    if {$optstart == 0} {
	    	set optstart [llength $vw]
	    	foreach a $FNA(cw,combowin,hpackdefs) {lappend vw $a}
	    }
	    for {set j 0} {$j < $optstart} {incr j} {
	    	set hw [lindex $vw $j]
		pack $hw -in $panel -side left
		for {set i $optstart} {$i < [llength $vw]} {incr i 2} {
		    pack configure $hw [lindex $vw $i] [lindex $vw [expr $i+1]]
		}
		raise $hw $panel
	    }
	}
		
}



proc _fna:cw_displayfiles {d_lb f_lb f_mnu} {

	global FNA
	global errorCode
	
	$d_lb delete 0 end
	$f_lb delete 0 end

	set d ".."
	if {$FNA(cwint,fileselect,showhidden)} {set gpat "\{.*,*\}"} {set gpat "*"}
	foreach f [lsort [glob -nocomplain $FNA(cwint,fileselect,dir)/$gpat]] {
	    if {[file isdir $f] && \
	        ![string match "." [file tail $f]] && \
	        ![string match ".." [file tail $f]]} {lappend d [file tail $f]}
	}
	foreach di $d {$d_lb insert end $di}

	if {$FNA(cwint,fileselect,showhidden)} \
	  {set gpat "\{.$FNA(cwint,fileselect,filter),$FNA(cwint,fileselect,filter)\}"} \
	  {set gpat "$FNA(cwint,fileselect,filter)"}

	foreach f [lsort [glob -nocomplain $FNA(cwint,fileselect,dir)/$gpat]] {
	  if {[file isfile $f]} {$f_lb insert end [file tail $f]}
	}
	
	$f_mnu delete 0 last
	if {[info exists FNA(cwint,fileselect,$FNA(cwint,fileselect,dir))]} {
	    foreach f $FNA(cwint,fileselect,$FNA(cwint,fileselect,dir)) {
	    	$f_mnu add command -label $f -command "
	    	  set FNA(cwint,fileselect,file) $f
	    	  $FNA(cwint,fileselect,actbutton) invoke
	    	"
	    }
	}

}


proc _fna:cw_filemenus {d_mnu d_lb f_mnu f_lb} {

	global FNA
	
	set d $FNA(cwint,fileselect,dir)
	
	if {[lsearch $FNA(cwint,fileselect,dirlist) $d] == -1} \
	  {lappend FNA(cwint,fileselect,dirlist) $d}
	
	if {![info exists FNA(cwint,fileselect,$d)]} {
	    set FNA(cwint,fileselect,$d) $FNA(cwint,fileselect,file)
	} \
	else {
	    if {[lsearch $FNA(cwint,fileselect,$d) $FNA(cwint,fileselect,file)] == -1} \
	      {lappend FNA(cwint,fileselect,$d) $FNA(cwint,fileselect,file)}
	}
	

}


proc fna:cw_fileselect {w dir message act_lbl {filter "*"} {modal 1} } {

    	global FNA
	global env

	if {$filter != ""} {set FNA(cwint,fileselect,filter) $filter}
	
    	if {$dir == ""} {
    	  if {$FNA(cwint,fileselect,dir) == ""} \
    	    {set FNA(cwint,fileselect,dir) [pwd]}
    	} \
    	else {set FNA(cwint,fileselect,dir) $dir}
    	set FNA(cwint,fileselect,cancel) 0
	    
    	set FNA(cwint,fileselect,window) $w
	toplevel $w
	if {$modal} {grab set $w}
	
	label $w.l -relief raised -bd 1 -text "$message"
		  
	fna:bw_scrolllistbox $w.dirs
	fna:bw_scrolllistbox $w.files

	if {[fna:util_tk3]} {
	  tk_listboxSingleSelect [$w.dirs listbox] [$w.files listbox]
	} else {
  	  [$w.dirs listbox] configure -selectmode browse
  	  [$w.files listbox] configure -selectmode browse
  	}
	
	fna:bw_mbentry $w.d_entry "Directory:" hor \
	  {-textvar FNA(cwint,fileselect,dir) -width 40}
	fna:bw_mbentry $w.f_entry "File:" hor \
	  {-textvar FNA(cwint,fileselect,file) -width 40}
	if {[fna:util_tk4]} {
	  [$w.d_entry menu] configure -tearoff 0
	  [$w.f_entry menu] configure -tearoff 0
	}
	fna:bw_labelentry $w.filter "Filter:" hor \
	  {-width 20 -textvar FNA(cwint,fileselect,filter)}
	
	button $w.home -text "Home" -relief raised -bd 1 -command "
  	  set FNA(cwint,fileselect,dir) $env(HOME)
  	  set FNA(cwint,fileselect,file) \"\"
  	  _fna:cw_displayfiles [$w.dirs listbox] [$w.files listbox] \
    	   [$w.f_entry menu]
  	"

	checkbutton $w.allfiles -text "All Files" -relief raised -bd 1 \
	  -command "
	  set FNA(cwint,fileselect,showhidden) \$allfiles
	  _fna:cw_displayfiles [$w.dirs listbox] [$w.files listbox] \
	    [$w.f_entry menu]
	"
	foreach d $FNA(cwint,fileselect,dirlist) {
	    [$w.d_entry menu] add command -label $d -command "
	    	set FNA(cwint,fileselect,dir) $d
	    	set FNA(cwint,fileselect,file) \"\"
	    	_fna:cw_displayfiles [$w.dirs listbox] [$w.files listbox] \
	    	  [$w.f_entry menu]
	    "
	}
	
	set FNA(cwint,fileselect,actbutton) \
	  [lindex [fna:cw_buttonpanelcmd $w.b 0 {
	    {{} {
	      _fna:cw_filemenus [$FNA(cwint,fileselect,window).d_entry menu] \
	        [$FNA(cwint,fileselect,window).dirs listbox] \
	        [$FNA(cwint,fileselect,window).f_entry menu] \
	        [$FNA(cwint,fileselect,window).files listbox]
	      set FNA(cwint,fileselect,cancel) 0
	    }} 
	    {Cancel {set FNA(cwint,fileselect,cancel) 1}}
	  }] 0]
	$FNA(cwint,fileselect,actbutton) configure -text "$act_lbl"
	
	bind [$w.d_entry entry] <Return> "
	    set FNA(temp) \[[$w.d_entry entry] get\]
	    if {\[string first \"/\" \$FNA(temp)\] != 0} return
	    set FNA(cwint,fileselect,dir) \"\$FNA(temp)\"
	    set FNA(cwint,fileselect,file) \"\"
	    _fna:cw_displayfiles [$w.dirs listbox] [$w.files listbox] \
	      [$w.f_entry menu]
	"
	
	bind [$w.filter entry] <Return> \
	  "_fna:cw_displayfiles [$w.dirs listbox] \
	  [$w.files listbox] [$w.f_entry menu]"
	
	bind [$w.dirs listbox] <Double-Button-1> "
	    set FNA(temp) \[[$w.dirs listbox] get \[[$w.dirs listbox] curselection\]\]
	    if {\"..\" == \$FNA(temp)} \
	      {set FNA(cwint,fileselect,dir) \[file dirname \$FNA(cwint,fileselect,dir)\]} \
	      {append FNA(cwint,fileselect,dir) \"/\$FNA(temp)\"}
	    set FNA(cwint,fileselect,file) \"\"
	    _fna:cw_displayfiles [$w.dirs listbox] [$w.files listbox] \
	      [$w.f_entry menu]
	"
	
# 	bind [$w.files listbox] <1> "+
# 	    set FNA(cwint,fileselect,file) \$BW(scrollListBox,sel)
# 	"
	
	if {[fna:util_tk3]} {
  	  bind [$w.files listbox] <1> {
    	    %W select from [%W nearest %y]
  	    set FNA(cwint,fileselect,file) [%W get [%W curselection]]
	  }
	} else {
	  bindtags [$w.files listbox] [list Listbox [$w.files listbox] . all]
	  bind [$w.files listbox] <1> {
	    set FNA(cwint,fileselect,file) [%W get [%W curselection]]
	  }
	}

	bind [$w.files listbox] <Double-1> "$FNA(cwint,fileselect,actbutton) invoke"
	bind [$w.f_entry entry] <Return> "$FNA(cwint,fileselect,actbutton) invoke"
	
    	_fna:cw_displayfiles [$w.dirs listbox] \
    	  [$w.files listbox] [$w.f_entry menu]

	fna:cw_combowin $w $w.l "$w.dirs $w.files" $w.d_entry $w.f_entry \
	  "$w.filter $w.home $w.allfiles" $w.b
	
	trace variable FNA(cwint,fileselect,file) w _fna:cw_trace
	set FNA(cwint,fileselect,file) ""
	
	if {$FNA(cwint,fileselect,autoposn) != "off"} {
	  switch $FNA(cwint,fileselect,autoposn) {
	    {ul}	{set geom "+0+0"}
	    {ur}	{set geom "-0+0"}
	    {ll}	{set geom "+0-0"}
	    {lr}	{set geom "-0-0"}
	    {ctr}	{set geom "ctr"}
	  }
	  if {$geom == "ctr"} {
	    wm iconify $w
	    update idletasks
  	    set h [expr "[winfo screenwidth $w]/2 - [winfo width $w]/2"]
  	    set v [expr "[winfo screenheight $w]/2 - [winfo height $w]/2"]
  	    set geom "+$h+$v"
	  }
	  wm geometry $w $geom
	  wm deiconify $w
	}

	tkwait variable FNA(cwint,fileselect,cancel)
	
	if {$FNA(cwint,fileselect,modal)} {grab release $w}
	trace vdelete FNA(cwint,fileselect,file) w _fna:cw_trace

	destroy $w
	if {$FNA(cwint,fileselect,cancel)} \
	  {return ""} \
	  {return $FNA(cwint,fileselect,dir)/$FNA(cwint,fileselect,file)}
	
}
